



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>扩展 DbUtility （1）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">扩展 DbUtility （1）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 12:00:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文原始路径： <a href="https://www.zybuluo.com/Ivony/note/14074" rel="external nofollow noreferrer">https://www.zybuluo.com/Ivony/note/14074</a></p>
<h2>前言</h2>
<p>DbUtility v3 是一个开源的轻量级数据库访问框架，源代码通过 Apache 协议发布，可以用于商业用途。最新的版本可以通过 NuGet 进行下载，项目及源代码下载地址：</p>
<p><a href="https://github.com/Ivony/DbUtility" rel="external nofollow noreferrer">https://github.com/Ivony/DbUtility</a></p>
<p>DbUtility 第一个版本公开于七年前，关于 DbUtility 的历史和 DbUtility 的使用，请参考下面这篇博客：</p>
<p><a href="http://www.cnblogs.com/Ivony/p/3659746.html" rel="external nofollow noreferrer">http://www.cnblogs.com/Ivony/p/3659746.html</a> <br />
<a href="https://www.zybuluo.com/Ivony/note/8277" rel="external nofollow noreferrer">https://www.zybuluo.com/Ivony/note/8277</a></p>
<p>作为一个开源项目，DbUtility 不仅仅致力于帮助大家简化数据库访问，也非常欢迎和期待大家的共同参与，不论是提交 Bug 或者单元测试，或是新的特性需求，以及自己动手为 DbUtility 增加更多有趣的功能，都是参与开源项目的方式。这篇文章面向所有有志于为 DbUtility 增添自定义功能的程序员，介绍 DbUtility 的扩展架构。</p>
<div>&nbsp;</div>
<h2>基本结构</h2>
<p>DbUtility v3 相较于之前版本的最大区别，也是 DbUtility v3 傲视其他轻量级数据库访问框架的地方，就是其优良的扩展架构。正如之前的介绍所述，DbUtility 将一个数据库查询分为三个部分：</p>
<ul><li>查询执行器</li>
<li>查询构建器</li>
<li>结果构建器</li></ul>
<p>这三个部分各有一个关键的接口，分别为：</p>
<ul><li>IDbExecutor where T : IDbQuery 定义某种类型查询的查询执行器。</li>
<li>IDbQuery 定义特定的数据库查询</li>
<li>IDbExecuteContext 定义数据库查询执行上下文，其中包括 DataReader 对象。</li></ul>
<p>譬如说 SqlDbUtility 类型便是面向 SQL Server 数据库的查询执行器实现类型，其声明为：</p>
<div>
<pre class="prettyprint linenums">public class SqlDbUtility :<br />
  IAsyncDbExecutor&lt;ParameterizedQuery&gt;,<br />
  IAsyncDbExecutor&lt;StoredProcedureQuery&gt;,<br />
  IDbTransactionProvider&lt;SqlDbUtility&gt;</pre>
</div>
<p><code>IAsyncDbExecutor</code> 是 <code>IDbExecutor</code> 的异步版本，表示可以异步执行指定类型的查询。可以看出来SqlDbUtility实现了两个查询执行器接口，分别是 <code>IAsyncDbExecutor&lt;ParameterizedQuery&gt;</code> 和 <code>IAsyncDbExecutor&lt;StoredProcedureQuery&gt;</code> 这表示这个类型的对象既可以执行 <code>ParameterizedQuery</code> 类型（参数化查询）的查询，也能执行 <code>StoredProcedureQuery</code> 类型（存储过程）的查询。</p>
<div>&nbsp;</div>
<h2>扩展查询构建器</h2>
<p>接下来我们尝试扩展一个查询构建方法，就像<code>T( "SELECT * FROM Users" )</code>一样。</p>
<p>假定我们经常会遇到一个场景，需要获取某个表的所有数据，如果直接使用T来构建参数化查询，则所需写的SQL语句很多： <code>SELECT * FROM TableName</code> ，我们希望简化为 <code>DT( "TableName" )</code> 的形式，该如何做呢？</p>
<p>首先我们要确定我们是否需要构建一种新的查询类型，因为构建新的查询类型，需要同时修改查询执行器，在本例中暂不涉及这么深入的问题。我们假定暂且借用参数化查询对象，只是简化其生成代码。</p>
<p>那么首先我们需要了解的一个事实是，所有的查询构建方法其实都是扩展方法，针对特定的查询执行器，对其进行扩展。如果我们生成的是一个参数化查询，那么我们需要一个参数化查询执行器才能执行，所以我们要针对参数化查询执行器进行扩展。首先新建一个扩展方法所需的静态类型：</p>
<div>
<pre class="prettyprint linenums">public static class MyExtensions<br />
{

}</pre>
</div>
<p><em>值得注意的是定义扩展方法的类型必须是静态类型。</em></p>
<p>然后我们添加一个扩展方法，因为我们最终生成的查询类型是参数化查询，所以我们需要对可以执行参数化查询的对象进行扩展，像这样：</p>
<div>
<pre class="prettyprint linenums">public static void DT( this IDbExecutor&lt;ParameterizedQuery&gt; executor, string tableName )<br />
{<br />
  throw new NotImplementedException();<br />
}</pre>
</div>
<p>请注意我这边的返回值类型还没有填写，因为这里涉及到另一个问题，单纯的查询对象是不能被执行的，为了达到 <code>db.DT( "Users" ).ExecuteDataTable()</code> 这样的效果，我们需要把查询对象和查询执行器捆绑起来，这个捆绑后的对象的类型为 <code>IDbExecutableQuery</code> （意为可执行的查询），所以我们需要把返回值设置为 <code>IDbExecutableQuery</code> 类型：</p>
<div>
<div>
<pre class="prettyprint linenums">public static IDbExecutableQuery DT( this IDbExecutor&lt;ParameterizedQuery&gt; executor, string tableName )<br />
{<br />
  throw new NotImplementedException();<br />
}</pre>
</div>
</div>
<p>DbUtility 已经为我们提供了现成的 <code>IDbExecutableQuery</code> 的实现，即 <code>DbExecutableQuery&lt;T&gt;</code> 类型，我们只需要构建一个查询对象，再连同查询执行器一起调用这个类型的构造函数即可：</p>
<div>
<pre class="prettyprint linenums">public static IDbExecutableQuery DT( this IDbExecutor&lt;ParameterizedQuery&gt; executor, string tableName )<br />
{<br />
  ParameterizedQuery query = null;<br />
  return new DbExecutableQuery&lt;ParameterizedQuery&gt;( executor, query );<br />
}</pre>
</div>
<p>最后，我们需要构建一个参数化查询对象，参数化查询对象作为基础查询对象，有很多种方式来构建，最常见的就是利用模板来构建，如果直接调用 <code>db.T</code> 方法，事实上构建出来的是 <code>DbExecutableQuery&lt;ParameterizedQuery&gt;</code> 类型的对象，好在系统提供了一个静态类型 <code>Db</code> 来对这些常见任务提供支持：</p>
<div>
<div>
<pre class="prettyprint linenums">public static IDbExecutableQuery DT( this IDbExecutor&lt;ParameterizedQuery&gt; executor, string tableName )<br />
{<br />
  ParameterizedQuery query = Db.T( "SELECT * FROM " + tableName );<br />
  return new DbExecutableQuery&lt;ParameterizedQuery&gt;( executor, query );<br />
}</pre>
</div>
</div>
<p>至此，我们的第一个扩展就已经完成了，马上来试一下：</p>
<div>
<pre class="prettyprint linenums">  var db = SqlDbUtility.Create( "Database" );<br />
  var data = db.DT( "Users" ).ExecuteDataTable();</pre>
</div>
<h2>尾声</h2>
<p>事实上你知道吗，<code>db.T</code> 这个方法，其内部实现就是这样的 <br />
<em>以下摘自DbUtility v3源代码：</em></p>
<div>
<pre class="prettyprint linenums">public static DbExecutableQuery&lt;ParameterizedQuery&gt; Template( this IDbExecutor&lt;ParameterizedQuery&gt; executor, string template, params object[] parameters )<br />
{<br />
  return new DbExecutableQuery&lt;ParameterizedQuery&gt;( executor, TemplateParser.ParseTemplate( template, parameters ) );<br />
}<br />
public static DbExecutableQuery&lt;ParameterizedQuery&gt; T( this IDbExecutor&lt;ParameterizedQuery&gt; executor, string template, params object[] parameters )<br />
{<br />
  return Template( executor, template, parameters );<br />
}</pre>
</div>
<p>接下来，我们把这个方法再进一步扩展，我们希望用户调用这个方法的时候，不再返回一个可执行的查询对象，而是直接执行查询，并将 DataTable 返回就好了，相信聪明的你应该很快就能想到怎样写了：</p>
<div>
<div>
<pre class="prettyprint linenums">  public static class MyExtensions<br />
  {<br />
    public static DataTable DT( this IDbExecutor&lt;ParameterizedQuery&gt; executor, string tableName )<br />
    {<br />
      ParameterizedQuery query = Db.T( "SELECT * FROM " + tableName );<br />
      return new DbExecutableQuery&lt;ParameterizedQuery&gt;( executor, query ).ExecuteDataTable();<br />
    }<br />
  }</pre>
</div>
</div>
<p>没错，借助优秀的可扩展架构，DbUtility可以被任意改造为任何你所喜欢 API 的形式，这种逆天的扩展性，是深深的植入在 DbUtility 整体架构模型设计中的。构成了 DbUtility 无与伦比的体验。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8z0okvq.html">C&num;函数式程序设计之用闭包封装数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kwjk58.html">Ubuntu nginx&colon; &lbrack;emerg&rsqb; bind&lpar;&rpar; to 0&period;0&period;0&period;0&colon;80 failed &lpar;13&colon; Permission denied&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1nxe38.html">&lbrack;转&rsqb;KDE&sol;QT与GNOME&sol;GTK比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ymypjq.html">【英语】Bingo口语笔记&lpar;33&rpar; - 面部器官系列</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0xwn4q.html">关于php程序员 解决问题的能力</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdleod8.html">【JQuery学习历程】2&period;JQuery选择器</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn3gxd8.html">你真的了解 console 吗</a>
		</li>
						<li><a href="https://www.batexi.com/a/96or6wj9.html">一元多项式Polynomial的C语言实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwlgvq.html">Python的&commat;符号</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpjg6zq.html">Egret 学习之简介，环境搭建及命令行语法 （一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj5gv09.html">关于mysql的初步学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1rlkxq.html">Mac OS X 安装后的简单设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexp16q.html">Spring Boot实战之逐行释义HelloWorld</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m356m8.html">仓储repository概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meg0vpq.html">Python-Django 模型层-多表查询</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd1n5d9.html">用Jmeter进行接口测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gwlnvq.html">【转】最近很火的 Safe Area 到底是什么</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o1w7j8.html">python中dict的fromkeys用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv247ro9.html">第7课 列表初始化（2）&lowbar;分析initializer&lowbar;list&amp;lt&semi;T&amp;gt&semi;的实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdw63n79.html">Vue&colon; ES6常用语法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/2q7ezjk9.html">前后端分离之前端项目构建（grunt&plus;require&plus;angular）</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnnj7xq.html">独立IP 与 共享IP</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1vrlzq.html">mysql存储过程详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdjjo0q.html">FIJ Jobs - 150316</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvedjj9.html">你真的了解UITabBarController吗？</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1vp75q.html">MySQL的表使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rn1o4q.html">&lpar;转载&rpar;SQL Reporting Services &lpar;Expression Examples&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zk3ex8.html">Solr部分更新MultiValued的Date日期字段时报错及解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq1v4d0q.html">《Java JDK7 学习笔记》课后练习题1</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zk3518.html">问题解决&mdash;&mdash;MFC resource&period;h 无法添加、提交到SVN</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
